import { View, Text, Image } from '@tarojs/components'
import { useState } from 'react'
import './index.less'
import GetPhoneNumber from '../getPhoneModal'

export default function DefaultPage1({setisGetUsePhone}) {

  //管理登录弹窗
  const [isLoginOpen, setisLoginOpen] = useState(false)
  return (
    <View className='default1_bg'>
      <Image src='https://oss.jm-kid.com/wx_5colorflower/defaultBg1.png'></Image>
      <Text className='default1_context'>登录查看更多绘本</Text>
      <View 
        className='default1_btn'
        onClick={()=>{setisLoginOpen(true)}}
      >
        <Text 
          className='default1_btn_text'
        >登录</Text>
      </View>

      <GetPhoneNumber
        onClose={setisGetUsePhone}
        modalVisible={isLoginOpen}
        onModalClose={() => setisLoginOpen(false)}
      ></GetPhoneNumber>
    </View>
  )
}
