import { View, Text, Image } from '@tarojs/components'
import Taro from '@tarojs/taro';
import './index.less'

export default function DefaultPage2() {
  const handleNavigateToMiniProgram = () => {
    Taro.navigateToMiniProgram({
      appId: 'wxbd3d383851fea776',
      path: 'pages/home/dashboard/index',
      success: (res) => {
        console.log('打开成功=>',res)
      },
      fail: (res) => {
        console.log('打开失败=>',res)
      }
    })
  }

  return (
    <View className='default1_bg'>
      <Image src='https://oss.jm-kid.com/wx_5colorflower/defaultBg2.png' className='default1_img'></Image>
      <Text className='default1_context'>当前没有订阅绘本，请前往商城购买哦~</Text>
      <View
        className='default1_btn'
        onClick={handleNavigateToMiniProgram}
      >
        <Text className='default1_btn_text'>去选购~</Text>
      </View>
    </View>
  )
}
