import { useEffect, useState } from 'react'
import Taro, { useLoad, useShareAppMessage, useShareTimeline, useDidHide } from '@tarojs/taro'
import { View, Text, Video, Image, ScrollView, CoverView, CoverImage } from '@tarojs/components'

import './index.less'

// const freeList = [
//   [
//     {
//       ResCover: "https://alihls.jm-kid.com/4e4442cc8bb04ee9945f7fc62f5d83c2/snapshots/a4835dffb64d4d62be067e7d73b1f9ed-00001.jpg",
//       ResDuration: 9,
//       ResId: 10001,
//       ResTitle: "森林的诞生_封面",
//       Tvpid: 'z3562su60q2',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/c0a62307b01c47f5bd9f96a105f23df1/snapshots/78fdf09eaf6446519f96afe8c1630480-00003.jpg",
//       ResDuration: 43,
//       ResId: 10001,
//       ResTitle: "森林的诞生P1",
//       Tvpid: 'e3562q26qqy',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/bd03e6684ee24f8b9ac91acb6c32c63d/snapshots/87a9f893f97e44529a7a90ed4522b593-00002.jpg",
//       ResDuration: 23,
//       ResId: 10001,
//       ResTitle: "森林的诞生P2",
//       Tvpid: 'p35627v9cm2',
//     },
//   ],
//   [
//     {
//       ResCover: "https://alihls.jm-kid.com/af78118009bb71ee80616732b78e0102/snapshots/a9ba85d7bbdb49c28001bd5fec1aa611-00002.jpg",
//       ResDuration: 17,
//       ResId: 10001,
//       ResTitle: "当我长大时_男孩_封面",
//       Tvpid: 'h3563rbx1uo',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/a4c5e0f009bb71ee8b936733a78e0102/snapshots/7b8886fbc9864850b36462e7752cebfd-00005.jpg",
//       ResDuration: 80,
//       ResId: 10001,
//       ResTitle: "当我长大时_男孩P1",
//       Tvpid: 't3563fjh7wg',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/ab68f1e009bb71eea28d6633b79f0102/snapshots/e803c8d22da14531be0dc53c118ce336-00004.jpg",
//       ResDuration: 50,
//       ResId: 10001,
//       ResTitle: "当我长大时_男孩P2",
//       Tvpid: 'q3563s8krn2',
//     },
//   ],
//   [
//     {
//       ResCover: "https://alihls.jm-kid.com/af78118009bb71ee80616732b78e0102/snapshots/a9ba85d7bbdb49c28001bd5fec1aa611-00002.jpg",
//       ResDuration: 42,
//       ResId: 10001,
//       ResTitle: "当我长大时_女孩_封面",
//       Tvpid: 'd3563zelkc4',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/a4c5e0f009bb71ee8b936733a78e0102/snapshots/7b8886fbc9864850b36462e7752cebfd-00005.jpg",
//       ResDuration: 28,
//       ResId: 10001,
//       ResTitle: "当我长大时_女孩P1",
//       Tvpid: 'm35631g0anx',
//     },
//     {
//       ResCover: "https://alihls.jm-kid.com/ab68f1e009bb71eea28d6633b79f0102/snapshots/e803c8d22da14531be0dc53c118ce336-00004.jpg",
//       ResDuration: 85,
//       ResId: 10001,
//       ResTitle: "当我长大时_女孩P2",
//       Tvpid: 'd3563bvtw1r',
//     },
//   ],
// ]

export default function Index() {

  // const [poemdata, setpoemdata] = useState({})
  // const [readnum, setreadnum] = useState('')
  // const [showVideo, setshowVideo] = useState(false)
  // const [showModal, setshowModal] = useState(false) //看一看和读一读图片点击弹窗
  // const [showvModal, setshowvModal] = useState(false) //视频播放结束弹窗
  // const [showftModal, setshowftModal] = useState(false)

  // const [yanDisplay, setyanDisplay] = useState({
  //   src:'',
  // })

  // const [changDisplay, setchangDisplay] = useState({
  //   src:'',
  // })

  // const [defaultvideo, setdefaultvideo] = useState('')
  const [ifchoose, setifchoose] = useState(1)
  const [desc, setdesc] = useState('')

  const [alldata, setalldata] = useState<any>([])
  const [displayindex, setdisplayindex] = useState({
    index: -1,
    src: '',
    poster: '',
    title: '',
  })
  const [isplay, setisplay] = useState(false)

  const [isFree, setisFree] = useState(false)

  const [isFullscreen, setIsFullscreen] = useState(false)

  const [playListOpen, setPlayListOpen] = useState(false)

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  // 页面隐藏（用于播放视频的时候进入小窗模式时发送埋点）
  useDidHide(() => {
    console.log('页面离开', alldata[displayindex['index']].ResId)
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/embedpoint',
      header: {
        authorization: `bearer ${Taro.getStorageSync('UserToken')}`
      },
      data: {
        timestamp: Date.now(),
        action_code: '1005006',
        value: alldata[displayindex['index']].ResId
      }
    })
  })

  useLoad((query) => {
    console.log('id=>', query.id)
    if(Taro.getStorageSync('UserToken')){
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/product/resource',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          prdt_id: query.id,
        },
        success: (res: any) => {
          const { data } = res.data
          const sources = data.Resource
          console.log('播放资源请求成功=>', res.data)
          setalldata(sources)
          setisFree(data.IsFree)

          if(data.IsFree){
            setdisplayindex({
              index: 0,
              src: sources[0].Tvpid,
              poster: sources[0].ResCover,
              title: sources[0].ResTitle,
            })
          }else{
            Taro.request({
              method: 'POST',
              url: 'https://api.jimeikid.com/jiyoumei/system/admin/employee/login',
              data: {
                "password": "WxBmGKupbl30+v4hfQC8aQ==",
                "userName": "VqwgIY4g7s9DanyyqsKP4g==",
              },
              success: (token_res) => {
                if(sources.length){
                  Taro.request({
                    method: 'GET',
                    url: 'https://api.jimeikid.com/jiyoumei/product/app/message/send/history/getPlayInfo',
                    header: {
                      authorization: token_res.data.data.token
                    },
                    data: {
                      token: sources[0].ResPwd,
                      videoId: sources[0].ResVcode,
                    },
                    success: function (rres) {
                      console.log('视频资源请求成功=>', rres)
                      //设置初始播放状态
                      setdisplayindex({
                        index: 0,
                        src: rres.data.data.body.playInfoList.playInfo[0].playURL,
                        poster: rres.data.data.body.videoBase.coverURL,
                        title: rres.data.data.body.playInfoList.playInfo[0].ResTitle || '',
                      })
                    }
                  })
                }
              },
            })
          }


        },
        fail: (err) => {
          console.log('播放资源请求失败=>', err)
        }
      })
    }else{
      //常规请求数据
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/product/resource',
        method: 'POST',
        data: {
          timestamp: Date.now(),
          prdt_id: query.id,
        },
        success: (res: any) => {
          console.log('播放资源请求成功=>', res.data)
          setalldata(res.data.data.Resource)
          setisFree(res.data.data.IsFree)
          setdisplayindex({
            index: 0,
            src: res.data.data.Resource[0].Tvpid,
            poster: res.data.data.Resource[0].ResCover,
            title: res.data.data.Resource[0].ResTitle,
          })
        },
        fail: (err) => {
          console.log('播放资源请求失败=>', err)
        }
      })
    }

  })


  const changedisplay = (item: any, index: any) => {

    if(!isFree){
      //根据点击行为设置播放状态
      console.log(index)
      console.log(alldata)
      //点击切换时更新视频
      Taro.request({
        method: 'POST',
        url: 'https://api.jimeikid.com/jiyoumei/system/admin/employee/login',
        data: {
          "password": "WxBmGKupbl30+v4hfQC8aQ==",
          "userName": "VqwgIY4g7s9DanyyqsKP4g==",
        },
        success: (token_res) => {
          Taro.request({
            method: 'GET',
            url: 'https://api.jimeikid.com/jiyoumei/product/app/message/send/history/getPlayInfo',
            header: {
              authorization: token_res.data.data.token
            },
            data: {
              token: alldata[index]['ResPwd'],
              videoId: alldata[index]['ResVcode']
            },
            success: function (rres) {
              console.log('4请求成功', rres)
              //设置初始播放状态
              setdisplayindex({
                index: index,
                src: rres.data.data.body.playInfoList.playInfo[0].playURL,
                poster: rres.data.data.body.videoBase.coverURL,
                title: rres.data.data.body.playInfoList.playInfo[0].ResTitle || '',
              })
            },
            fail: (err) => {
              console.log(err)
            }
          })
        },
      })
    }else{
      //腾讯视频固定数据
      setdisplayindex({
        index: index,
        src: item.Tvpid,
        poster: item.ResCover,
        title: item.ResTitle,
      })
    }
  }

  const continuePlay = () => {
    //连播
    let nowindex = displayindex['index']
    console.log('nowindex:', nowindex, 'alldata.length:', alldata.length)

    //当播放至最后一项时，停在当前视频
    if (nowindex === alldata.length - 1) {
      console.log('播放结束')
    } else {

      if(!isFree){
        //连播时更新视频
        Taro.request({
          method: 'POST',
          url: 'https://api.jimeikid.com/jiyoumei/system/admin/employee/login',
          data: {
            "password": "WxBmGKupbl30+v4hfQC8aQ==",
            "userName": "VqwgIY4g7s9DanyyqsKP4g==",
          },
          success: (token_res) => {
            Taro.request({
              method: 'GET',
              url: 'https://api.jimeikid.com/jiyoumei/product/app/message/send/history/getPlayInfo',
              header: {
                authorization: token_res.data.data.token
              },
              data: {
                token: alldata[nowindex + 1]['ResPwd'],
                videoId: alldata[nowindex + 1]['ResVcode']
              },
              success: function (rres) {
                console.log('视频内容请求成功', rres)
                //设置初始播放状态
                setdisplayindex({
                  index: nowindex + 1,
                  src: rres.data.data.body.playInfoList.playInfo[0].playURL,
                  poster: rres.data.data.body.videoBase.coverURL,
                  title: rres.data.data.body.playInfoList.playInfo[0].ResTitle || '',
                })

                // 埋点
                Taro.request({
                  method: 'POST',
                  url: 'https://interapi.jm-kid.com/api/embedpoint',
                  header: {
                    authorization: `bearer ${Taro.getStorageSync('UserToken')}`
                  },
                  data: {
                    timestamp: Date.now(),
                    action_code: '1005007',
                    value: alldata[nowindex].ResId
                  }
                })
              }
            })
          },
        })
      }else{
        //腾讯视频固定数据
        setdisplayindex({
          index: nowindex + 1,
          src: alldata[nowindex + 1].Tvpid,
          poster: alldata[nowindex + 1].ResCover,
          title: alldata[nowindex + 1].ResTitle,
        })
      }

    }

  }

  // 暂停播放回调
  const pausePlay = () => {
    // 埋点
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/embedpoint',
      header: {
        authorization: `bearer ${Taro.getStorageSync('UserToken')}`
      },
      data: {
        timestamp: Date.now(),
        action_code: '1005002',
        value: alldata[displayindex['index']].ResId
      }
    })
    return
  }

  const provingCdKey = () => {
    //记录验证成功后退出函数，避免反复执行
    setisplay(true)

    // 埋点
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/embedpoint',
      header: {
        authorization: `bearer ${Taro.getStorageSync('UserToken')}`
      },
      data: {
        timestamp: Date.now(),
        action_code: '1005003',
        value: alldata[displayindex['index']].ResId
      }
    })
    return
  }

  const getDuration = (num: number) => {
    let minutes = Math.floor(num / 60);
    let seconds = Math.floor(num % 60);
    // let result = minutes + ':' + seconds;
    let result = minutes.toString().padStart(2, '0') + ':' + seconds.toString().padStart(2, '0');
    return result;
  }

  // 视频全屏回调
  const fullScreenChange = (e: any) => {
    const { fullScreen } = e.detail
    fullScreen || setPlayListOpen(false)
    setIsFullscreen(fullScreen)

    // 埋点
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/embedpoint',
      header: {
        authorization: `bearer ${Taro.getStorageSync('UserToken')}`
      },
      data: {
        timestamp: Date.now(),
        action_code: fullScreen ? '1005004' : '1005005',
        value: alldata[displayindex['index']].ResId
      }
    })
  }

  // 展示选集列表
  const showPlayList = () => {
    setPlayListOpen(!playListOpen)
  }

  const videoClick = () => {
    setPlayListOpen(false)
  }

  return (
    <View className='bgview' style={{ width: '100%', overflow: 'hidden' }}>
      {/* pad小程序 */}
      <View className='sixteen-to-nine-container'>
        <View className='content'>
          {
            !isFree ?
              <>
                <Video
                  className='jimeiVideo'
                  title={displayindex.title}
                  src={displayindex['src']}
                  poster={displayindex['poster']}
                  initialTime={0}
                  controls
                  autoplay
                  enablePlayGesture
                  vslideGesture
                  showScreenLockButton
                  showBackgroundPlaybackButton
                  loop={false}
                  muted={false}
                  onClick={() => videoClick()}
                  onEnded={() => continuePlay()}
                  onPause={() => pausePlay()}
                  onPlay={() => provingCdKey()}
                  onFullScreenChange={(e) => fullScreenChange(e)}
                  direction={90}
                  id='topvideo'
                  objectFit='contain'
                ></Video>
                {isFullscreen && <CoverView className='select-epi' onClick={showPlayList}>选集</CoverView>}
               </> :
              null
          }
          {
            isFree ?
              //@ts-ignore
              <player-component
                className='jimeiVideo'
                title={displayindex.title}
                id='tvp-id'
                playerid='tvp'
                vid={displayindex.src}
                onEnded={() => continuePlay()}
                onPause={() => pausePlay()}
                onPlay={() => provingCdKey()}
                autoplay
              /> :
              null
          }
        </View>
      </View>

      <ScrollView
        className='displayList'
        scrollY
        scrollWithAnimation
      >
        {
          alldata.map((item : any, index: number) =>
            <View className='card' key={item['ResId']} style={index == displayindex['index'] ? { backgroundColor: '#efefef' } : {}} onClick={() => changedisplay(item, index)} >
              <View className='card-left'>
                <Image className='card-image' src={item['ResCover']} mode='aspectFill'></Image>
                <View className='card-textarea'>
                  <Text className='card-textarea-title'>{item['ResTitle']}</Text>
                  <View className='card-textarea-content'>
                    <Image src='https://oss.jm-kid.com/wx_5colorflower/testIcon.svg' className='content-icon'></Image>
                    <Text className='content-text'>{getDuration(item['ResDuration'])}</Text>
                  </View>
                  </View>
                </View>
              <Image className='card-button' src={isplay && displayindex['index'] == index ? 'https://oss.jm-kid.com/wx_5colorflower/newplay.gif' : 'https://oss.jm-kid.com/wx_5colorflower/button_01.svg'}></Image>
            </View>
          )
        }
      </ScrollView>

      {/* 全屏播放状态下的视频列表 */}
      {
        playListOpen &&
        <CoverView
          className='fullDisplayList'
          scrollX
          scrollWithAnimation
          // enableFlex
        >
          <CoverView className='card-epi'>选集</CoverView>
          <CoverView className='card-inner'>
            {
              alldata.map((item : any, index: number) =>
                <CoverView className='card' key={item['ResId']} onClick={() => changedisplay(item, index)} >
                  <CoverView className='card-image-wrap'>
                    <CoverImage className='card-image' src={item['ResCover']} mode='aspectFill'></CoverImage>
                    {displayindex['index'] == index && <CoverView className='card-playing-mask'>正在播放</CoverView>}
                  </CoverView>
                  <CoverView className='card-title'>{item['ResTitle']}</CoverView>
                </CoverView>
              )
              }
          </CoverView>
        </CoverView>
      }
    </View>
  )
}
