import { View, WebView } from '@tarojs/components'
import { useLoad } from '@tarojs/taro'
import React, { useState } from 'react'

export default function ListenBookDisplay() {

  const [prdtId, setprdtId] = useState(-1)

  useLoad((query)=> {
    console.log(query.prdtId)
    setprdtId(query.prdtId)
  })

  return (
    <WebView
      src={`https://audioplay.jm-kid.com/listen?prdtId=${prdtId}`}
    ></WebView>
  )
}
