import { View, WebView } from '@tarojs/components'
import { useLoad } from '@tarojs/taro'
import React, { useState } from 'react'

export default function ListenDisplay() {

  const [prdtId, setprdtId] = useState(-1)

  const [resId, setresId] = useState(-1)

  useLoad((query)=> {
    console.log(query.prdtId, query.resId)
    setprdtId(query.prdtId)
    setresId(query.resId)
  })

  return (
    <WebView
      src={`https://audioplay.jm-kid.com?prdtId=${prdtId}&resId=${resId}&_=${Date.now()}`}
    ></WebView>
  )
}
