import { ScrollView, View , Image} from '@tarojs/components'
import React, { useEffect, useState } from 'react'
import Taro, { useDidShow, useLoad } from '@tarojs/taro'
import './index.less'


// const typetypeList = [
//   {
//     index: 0,
//     name: 'dqwsq'
//   },
//   {
//     index: 1,
//     name: 'dqwsq'
//   },
//   {
//     index: 2,
//     name: 'dqwsq'
//   },
//   {
//     index: 3,
//     name: 'dqwsq'
//   },
//   {
//     index: 4,
//     name: 'dqwsq'
//   },
//   {
//     index: 5,
//     name: 'dqwsq'
//   },
//   {
//     index: 6,
//     name: 'dqwsq'
//   },
//   {
//     index: 7,
//     name: 'dqwsq'
//   },
//   {
//     index: 8,
//     name: 'dqwsq'
//   },
//   {
//     index: 9,
//     name: 'dqwsq'
//   },
//   {
//     index: 10,
//     name: 'dqwsq'
//   },
//   {
//     index: 11,
//     name: 'dqwsq'
//   },
//   {
//     index: 12,
//     name: 'dqwsq'
//   },
//   {
//     index: 13,
//     name: 'dqwsq'
//   },
//   {
//     index: 14,
//     name: 'dqwsq'
//   },
//   {
//     index: 15,
//     name: 'dqwsq'
//   },
//   {
//     index: 16,
//     name: 'dqwsq'
//   },
//   {
//     index: 17,
//     name: 'dqwsq'
//   },
//   {
//     index: 18,
//     name: 'dqwsq'
//   },
//   {
//     index: 19,
//     name: 'dqwsq'
//   },
//   {
//     index: 20,
//     name: 'dqwsq'
//   },
//   {
//     index: 21,
//     name: 'dqwsq'
//   },
// ]

export default function SingleType() {

  const [chooseType, setchooseType] = useState(0)

  const [choooseTypeType, setchoooseTypeType] = useState(0)

  const [typeList, settypeList] = useState<any>([])

  const [typeCode, settypeCode] = useState('')

  const [typetypeList, settypetypeList] = useState<any>([])

  const [pageTitle, setpageTitle] = useState('')

  useLoad((query)=>{
    console.log('query=>', query.index)

    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/audio/category',
      data: {
        timestamp: Date.now(),
      },
      success: (res) => {
        console.log('熏听区两级分类数据请求成功' ,res.data)
        for(let i = 0; i < res.data.data.category.length; i++){
          if(res.data.data.category[i].class_code === query.index){
            settypeList(res.data.data.category[i].children)
            setpageTitle(res.data.data.category[i].class_name)

            settypeCode(res.data.data.category[i].children[0].class_code)
          }
        }
      }
    })
  })

  useEffect(()=> {
    if(typeCode!== ''){
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/class/product',
        data: {
          timestamp: Date.now(),
          class_code: typeCode
        },
        success: (res) => {
          console.log('获取金刚区内容列表数据请求成功' ,res.data)
          settypetypeList(res.data.data.products)
        }
      })
    }

  }, [typeCode])

  const handleChooseTypeType = (index: number) => {
    setchoooseTypeType(index)
    settypeCode(typeList[index].class_code)
  }

  const handleBack = () => {
    Taro.navigateBack()
  }

  const handleDetail = (prdtId: number) => {
    Taro.navigateTo({
      url: '/pages/ListenDetail/index?prdtId=' + prdtId
    })
  }

  return (
    <View className='singleType_bg'>
      <View className='header'>
        <View
          className='back'
          onClick={handleBack}
        ></View>
        <View className='title'>{pageTitle}</View>
      </View>
      <View className='main_context'>
        <View className='type_container'>
          <ScrollView
            className='typelist'
            scrollY
            scrollWithAnimation
          >
              {
                typeList.map((item: any, index: number) => (
                  <View
                    key={index}
                    className={`item ${choooseTypeType === index ? 'active' : choooseTypeType === index + 1 ? 'active-prev' : choooseTypeType === index - 1 ? 'active-next' : ''}`}
                    onClick={()=>handleChooseTypeType(index)}
                  >{item.class_name}</View>
                ))
              }
          </ScrollView>
        </View>

        <View className='product_container'>
          <ScrollView
            className='product'
            scrollY
            scrollWithAnimation
          >
            <View className='container'>
              {
                typetypeList.map((item: any, index: number) => (
                  <View
                    key={index}
                    className='item'
                    onClick={()=>handleDetail(item.PrdtId)}
                  >
                    <Image
                      className='icon'
                      src={item.PrdtCover}
                      lazyLoad
                    ></Image>
                    <View className='title'>{item.PrdtTitle}</View>
                  </View>
                ))
              }
            </View>
          </ScrollView>
        </View>


      </View>
    </View>
  )
}
