import { View, Image, Text} from '@tarojs/components'
import { useState } from 'react';
import Taro, { useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import './index.less'
import GetPhoneNumber from '../../components/getPhoneModal';


export default function Store() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  const handleNavigateToMiniProgram = () => {
    Taro.navigateToMiniProgram({
      appId: 'wxbd3d383851fea776',
      path: 'pages/home/dashboard/index',
      success: (res) => {
        console.log('打开成功=>',res)
      },
      fail: (res) => {
        console.log('打开失败=>',res)
      }
    })
  }
  
  return (
    <View className='default1_bg'>
      <Image src='https://oss.jm-kid.com/wx_5colorflower/defaultBg1.png' className='default1_img'></Image>
      {/* <Text className='default1_context'>当前没有订阅绘本，请前往商城购买哦~</Text> */}
      <View 
        className='default1_btn'
        onClick={()=>handleNavigateToMiniProgram()}    
      >
        <Text 
          className='default1_btn_text'
        >
          去选购~
        </Text>
      </View>
    </View>
  )
}
