export default defineAppConfig({
  pages: [
    'pages/Home/index',
    'pages/Subscribe/index',
    'pages/Store/index',
    'pages/UserHome/index',
    'pages/UserHome/UserPersonalInfo/index',
    'pages/UserHome/UserSubscribe/index',
    'pages/UserHome/UserMessage/index',
    'pages/CollectionDetail/index',
    'pages/SingleDetail/index',
    'pages/AudioInterface/index',
    'pages/DisplayVideo/index',
    'pages/SearchDetail/index',
    'pages/Listen/index',
    'pages/ListenType/MainType/index',
    'pages/ListenType/SingleType/index',
    'pages/ListenRegion/index',
    'pages/ListenDetail/index',
    'pages/ListenDisplay/index',
    'pages/ListenSearch/index',
    'pages/ListenBookDisplay/index',
    'pages/Share/index',
    'pages/Customer/index',
    'pages/Vip/index',
  ],
  tabBar: {
    color: '#999',
    selectedColor: '#333',
    backgroundColor: '#fff',
    borderStyle: 'black',
    list: [
      {
        pagePath: 'pages/Home/index',
        text: '首页',
        iconPath: 'assets/images/home.png',
        selectedIconPath: 'assets/images/home_active.png'
      },
      {
        pagePath: 'pages/Subscribe/index',
        text: '绘本',
        iconPath: 'assets/images/subscribe.png',
        selectedIconPath: 'assets/images/subscribe_active.png'
      },
      {
        pagePath: 'pages/Listen/index',
        text: '熏听',
        iconPath: 'assets/images/listen.png',
        selectedIconPath: 'assets/images/listen_active.png'
      },
      {
        pagePath: 'pages/UserHome/index',
        text: '我的',
        iconPath: 'assets/images/user.png',
        selectedIconPath: 'assets/images/user_active.png'
      },
    ]
  },
  window: {
    backgroundTextStyle: 'light',
    navigationBarBackgroundColor: '#fff',
    navigationBarTitleText: 'WeChat',
    navigationBarTextStyle: 'black'
  },
  plugins: {
    "player": {
      "version": "2.5.2",
      "provider": "wxa75efa648b60994b"
    }
  },
  "requiredBackgroundModes": ["audio", "location"]
})
