import { Image } from '@tarojs/components'
import Taro, { useShareAppMessage, useShareTimeline, useLoad } from '@tarojs/taro'
import './index.less'

export default function Customer() {

  useShareAppMessage(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useLoad(()=>{
    if(Taro.getStorageSync('UserToken')){
      // 埋点
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/embedpoint',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          action_code: '1002001',
          value: 0
        }
      })
    }
  })

  return (
    <Image
      src='https://oss.jm-kid.com/wx_5colorflower/icons/customer.jpeg'
      className='pic'
      mode='aspectFill'
      show-menu-by-longpress
    ></Image>
  )
}
